<?php
defined('_JEXEC') or die('Restricted access');

class plgSystemWebgains extends JPlugin
{	
	private $finish_script = '';
	
    public function __construct(&$subject, $config = array()){
        parent::__construct($subject, $config);  
    }	
	
	public function onBeforeRender(){
        if (JFactory::getDocument()->getType() == 'html' && JFactory::getApplication()->isClient('site')){
            $document = JFactory::getDocument();
            //$document->addCustomTag("<script>"."</script>");			
			$script = "(function(w,e,b,g,a,i,n,s){w['ITCLKOBJ']=a;w[a]=w[a]||function(){(w[a].q=w[a].q||[]).push(arguments)},w[a].l=1*new Date();i=e.createElement(b),n=e.getElementsByTagName(b)[0];i.async=1;i.src=g;n.parentNode.insertBefore(i,n)})(window,document,'script','https://analytics.webgains.io/clk.min.js','ITCLKQ');"
			."ITCLKQ('set', 'internal.api', true);"
			."ITCLKQ('set', 'internal.cookie', true);"
			."ITCLKQ('click');";
			
			$document->addScriptDeclaration($script);
			if ($this->finish_script) {
				$document->addScriptDeclaration($this->finish_script);
			}
        }
    }
    
    public function onBeforeDisplayCheckoutFinish(&$text, &$order_id) {
        if ($order_id){
            $jshopConfig = JSFactory::getConfig();
            $order = JTable::getInstance('order', 'jshop');
            $order->load($order_id);
			$order->getAllItems();
			if ($order->coupon_id) {
				$coupon = JTable::getInstance('coupon', 'jshop'); 
				$coupon->load($order->coupon_id);
			}
            $coupon_code = ($order->coupon_id) ? $order->coupon_code : '';
            
            $wgMultiple = 1;

            $wgCustomerID = $this->params->get('customerID', ''); # Bitte nicht ohne vorherige Absprache verwenden
            $wgProductID = $this->params->get('productID', ''); # Bitte nicht ohne vorherige Absprache verwenden
			
			$lang = JFactory::getLanguage();
            $language = str_replace('-', '_', $lang->getTag());
			$netto = $this->getNettoPriceProductOrder($order) - $order->order_discount;
			
			$script = "(function(w,e,b,g,a,i,n,s){w['ITCVROBJ']=a;w[a]=w[a]||function(){
				(w[a].q=w[a].q||[]).push(arguments)},w[a].l=1*new Date();i=e.createElement(b),
				n=e.getElementsByTagName(b)[0];i.async=1;i.src=g;n.parentNode.insertBefore(i,n)
			})(window,document,'script','https://analytics.webgains.io/cvr.min.js','ITCVRQ');
			ITCVRQ('set', 'trk.programId', ".$this->params->get('programID', '0').");			
			ITCVRQ('set', 'cvr', {
				value: '".round($netto, 2)."',
				currency: '".$order->currency_code_iso."',
				language: '".$language."',
				eventId: ".$this->params->get('eventID', '0').",
				orderReference : '".$order_id."',
				comment: '".addslashes($this->params->get('comment', ''))."',
				multiple: '".$wgMultiple."',
				checksum: '',
				items: '',
				customerId: '',
				voucherId: '".$coupon_code."'
			});
			ITCVRQ('conversion');";
			
			$this->finish_script = $script;			
		}
    }
	
	function getNettoPriceProductOrder($order) {
		$items = $order->getAllItems();		
		$netto = 0;
		foreach($items as $item) {
			$price = $item->product_item_price * $item->product_quantity;
			if ($order->display_price == 0) {
				$price = $price / (1+ $item->product_tax / 100);
			}
			$netto += $price;
		}
		return $netto;
	}
}